// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
#[allow(missing_docs)] // documentation missing in model
#[non_exhaustive]
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::fmt::Debug)]
pub struct ListLexiconsOutput {
    /// <p>A list of lexicon names and attributes.</p>
    pub lexicons: ::std::option::Option<::std::vec::Vec<crate::types::LexiconDescription>>,
    /// <p>The pagination token to use in the next request to continue the listing of lexicons. <code>NextToken</code> is returned only if the response is truncated.</p>
    pub next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl ListLexiconsOutput {
    /// <p>A list of lexicon names and attributes.</p>
    ///
    /// If no value was sent for this field, a default will be set. If you want to determine if no value was sent, use `.lexicons.is_none()`.
    pub fn lexicons(&self) -> &[crate::types::LexiconDescription] {
        self.lexicons.as_deref().unwrap_or_default()
    }
    /// <p>The pagination token to use in the next request to continue the listing of lexicons. <code>NextToken</code> is returned only if the response is truncated.</p>
    pub fn next_token(&self) -> ::std::option::Option<&str> {
        self.next_token.as_deref()
    }
}
impl ::aws_types::request_id::RequestId for ListLexiconsOutput {
    fn request_id(&self) -> Option<&str> {
        self._request_id.as_deref()
    }
}
impl ListLexiconsOutput {
    /// Creates a new builder-style object to manufacture [`ListLexiconsOutput`](crate::operation::list_lexicons::ListLexiconsOutput).
    pub fn builder() -> crate::operation::list_lexicons::builders::ListLexiconsOutputBuilder {
        crate::operation::list_lexicons::builders::ListLexiconsOutputBuilder::default()
    }
}

/// A builder for [`ListLexiconsOutput`](crate::operation::list_lexicons::ListLexiconsOutput).
#[derive(::std::clone::Clone, ::std::cmp::PartialEq, ::std::default::Default, ::std::fmt::Debug)]
#[non_exhaustive]
pub struct ListLexiconsOutputBuilder {
    pub(crate) lexicons: ::std::option::Option<::std::vec::Vec<crate::types::LexiconDescription>>,
    pub(crate) next_token: ::std::option::Option<::std::string::String>,
    _request_id: Option<String>,
}
impl ListLexiconsOutputBuilder {
    /// Appends an item to `lexicons`.
    ///
    /// To override the contents of this collection use [`set_lexicons`](Self::set_lexicons).
    ///
    /// <p>A list of lexicon names and attributes.</p>
    pub fn lexicons(mut self, input: crate::types::LexiconDescription) -> Self {
        let mut v = self.lexicons.unwrap_or_default();
        v.push(input);
        self.lexicons = ::std::option::Option::Some(v);
        self
    }
    /// <p>A list of lexicon names and attributes.</p>
    pub fn set_lexicons(mut self, input: ::std::option::Option<::std::vec::Vec<crate::types::LexiconDescription>>) -> Self {
        self.lexicons = input;
        self
    }
    /// <p>A list of lexicon names and attributes.</p>
    pub fn get_lexicons(&self) -> &::std::option::Option<::std::vec::Vec<crate::types::LexiconDescription>> {
        &self.lexicons
    }
    /// <p>The pagination token to use in the next request to continue the listing of lexicons. <code>NextToken</code> is returned only if the response is truncated.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.next_token = ::std::option::Option::Some(input.into());
        self
    }
    /// <p>The pagination token to use in the next request to continue the listing of lexicons. <code>NextToken</code> is returned only if the response is truncated.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.next_token = input;
        self
    }
    /// <p>The pagination token to use in the next request to continue the listing of lexicons. <code>NextToken</code> is returned only if the response is truncated.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        &self.next_token
    }
    pub(crate) fn _request_id(mut self, request_id: impl Into<String>) -> Self {
        self._request_id = Some(request_id.into());
        self
    }

    pub(crate) fn _set_request_id(&mut self, request_id: Option<String>) -> &mut Self {
        self._request_id = request_id;
        self
    }
    /// Consumes the builder and constructs a [`ListLexiconsOutput`](crate::operation::list_lexicons::ListLexiconsOutput).
    pub fn build(self) -> crate::operation::list_lexicons::ListLexiconsOutput {
        crate::operation::list_lexicons::ListLexiconsOutput {
            lexicons: self.lexicons,
            next_token: self.next_token,
            _request_id: self._request_id,
        }
    }
}
