// Code generated by software.amazon.smithy.rust.codegen.smithy-rs. DO NOT EDIT.
pub use crate::operation::list_speech_synthesis_tasks::_list_speech_synthesis_tasks_output::ListSpeechSynthesisTasksOutputBuilder;

pub use crate::operation::list_speech_synthesis_tasks::_list_speech_synthesis_tasks_input::ListSpeechSynthesisTasksInputBuilder;

impl crate::operation::list_speech_synthesis_tasks::builders::ListSpeechSynthesisTasksInputBuilder {
    /// Sends a request with this input using the given client.
    pub async fn send_with(
        self,
        client: &crate::Client,
    ) -> ::std::result::Result<
        crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksOutput,
        ::aws_smithy_runtime_api::client::result::SdkError<
            crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksError,
            ::aws_smithy_runtime_api::client::orchestrator::HttpResponse,
        >,
    > {
        let mut fluent_builder = client.list_speech_synthesis_tasks();
        fluent_builder.inner = self;
        fluent_builder.send().await
    }
}
/// Fluent builder constructing a request to `ListSpeechSynthesisTasks`.
///
/// <p>Returns a list of SpeechSynthesisTask objects ordered by their creation date. This operation can filter the tasks by their status, for example, allowing users to list only tasks that are completed.</p>
#[derive(::std::clone::Clone, ::std::fmt::Debug)]
pub struct ListSpeechSynthesisTasksFluentBuilder {
    handle: ::std::sync::Arc<crate::client::Handle>,
    inner: crate::operation::list_speech_synthesis_tasks::builders::ListSpeechSynthesisTasksInputBuilder,
    config_override: ::std::option::Option<crate::config::Builder>,
}
impl
    crate::client::customize::internal::CustomizableSend<
        crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksOutput,
        crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksError,
    > for ListSpeechSynthesisTasksFluentBuilder
{
    fn send(
        self,
        config_override: crate::config::Builder,
    ) -> crate::client::customize::internal::BoxFuture<
        crate::client::customize::internal::SendResult<
            crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksOutput,
            crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksError,
        >,
    > {
        ::std::boxed::Box::pin(async move { self.config_override(config_override).send().await })
    }
}
impl ListSpeechSynthesisTasksFluentBuilder {
    /// Creates a new `ListSpeechSynthesisTasksFluentBuilder`.
    pub(crate) fn new(handle: ::std::sync::Arc<crate::client::Handle>) -> Self {
        Self {
            handle,
            inner: ::std::default::Default::default(),
            config_override: ::std::option::Option::None,
        }
    }
    /// Access the ListSpeechSynthesisTasks as a reference.
    pub fn as_input(&self) -> &crate::operation::list_speech_synthesis_tasks::builders::ListSpeechSynthesisTasksInputBuilder {
        &self.inner
    }
    /// Sends the request and returns the response.
    ///
    /// If an error occurs, an `SdkError` will be returned with additional details that
    /// can be matched against.
    ///
    /// By default, any retryable failures will be retried twice. Retry behavior
    /// is configurable with the [RetryConfig](aws_smithy_types::retry::RetryConfig), which can be
    /// set when configuring the client.
    pub async fn send(
        self,
    ) -> ::std::result::Result<
        crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksOutput,
        ::aws_smithy_runtime_api::client::result::SdkError<
            crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksError,
            ::aws_smithy_runtime_api::client::orchestrator::HttpResponse,
        >,
    > {
        let input = self
            .inner
            .build()
            .map_err(::aws_smithy_runtime_api::client::result::SdkError::construction_failure)?;
        let runtime_plugins = crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasks::operation_runtime_plugins(
            self.handle.runtime_plugins.clone(),
            &self.handle.conf,
            self.config_override,
        );
        crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasks::orchestrate(&runtime_plugins, input).await
    }

    /// Consumes this builder, creating a customizable operation that can be modified before being sent.
    pub fn customize(
        self,
    ) -> crate::client::customize::CustomizableOperation<
        crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksOutput,
        crate::operation::list_speech_synthesis_tasks::ListSpeechSynthesisTasksError,
        Self,
    > {
        crate::client::customize::CustomizableOperation::new(self)
    }
    pub(crate) fn config_override(mut self, config_override: impl ::std::convert::Into<crate::config::Builder>) -> Self {
        self.set_config_override(::std::option::Option::Some(config_override.into()));
        self
    }

    pub(crate) fn set_config_override(&mut self, config_override: ::std::option::Option<crate::config::Builder>) -> &mut Self {
        self.config_override = config_override;
        self
    }
    /// Create a paginator for this request
    ///
    /// Paginators are used by calling [`send().await`](crate::operation::list_speech_synthesis_tasks::paginator::ListSpeechSynthesisTasksPaginator::send) which returns a [`PaginationStream`](aws_smithy_async::future::pagination_stream::PaginationStream).
    pub fn into_paginator(self) -> crate::operation::list_speech_synthesis_tasks::paginator::ListSpeechSynthesisTasksPaginator {
        crate::operation::list_speech_synthesis_tasks::paginator::ListSpeechSynthesisTasksPaginator::new(self.handle, self.inner)
    }
    /// <p>Maximum number of speech synthesis tasks returned in a List operation.</p>
    pub fn max_results(mut self, input: i32) -> Self {
        self.inner = self.inner.max_results(input);
        self
    }
    /// <p>Maximum number of speech synthesis tasks returned in a List operation.</p>
    pub fn set_max_results(mut self, input: ::std::option::Option<i32>) -> Self {
        self.inner = self.inner.set_max_results(input);
        self
    }
    /// <p>Maximum number of speech synthesis tasks returned in a List operation.</p>
    pub fn get_max_results(&self) -> &::std::option::Option<i32> {
        self.inner.get_max_results()
    }
    /// <p>The pagination token to use in the next request to continue the listing of speech synthesis tasks.</p>
    pub fn next_token(mut self, input: impl ::std::convert::Into<::std::string::String>) -> Self {
        self.inner = self.inner.next_token(input.into());
        self
    }
    /// <p>The pagination token to use in the next request to continue the listing of speech synthesis tasks.</p>
    pub fn set_next_token(mut self, input: ::std::option::Option<::std::string::String>) -> Self {
        self.inner = self.inner.set_next_token(input);
        self
    }
    /// <p>The pagination token to use in the next request to continue the listing of speech synthesis tasks.</p>
    pub fn get_next_token(&self) -> &::std::option::Option<::std::string::String> {
        self.inner.get_next_token()
    }
    /// <p>Status of the speech synthesis tasks returned in a List operation</p>
    pub fn status(mut self, input: crate::types::TaskStatus) -> Self {
        self.inner = self.inner.status(input);
        self
    }
    /// <p>Status of the speech synthesis tasks returned in a List operation</p>
    pub fn set_status(mut self, input: ::std::option::Option<crate::types::TaskStatus>) -> Self {
        self.inner = self.inner.set_status(input);
        self
    }
    /// <p>Status of the speech synthesis tasks returned in a List operation</p>
    pub fn get_status(&self) -> &::std::option::Option<crate::types::TaskStatus> {
        self.inner.get_status()
    }
}
